<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- $Id: opml2xbel.xsl,v 1.1 2001/05/27 17:27:47 asc Exp asc $ -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method = "xml" version = "1.0" encoding="UTF-8" indent = "yes" />

<xsl:template match = "/opml" >
<xbel>
 <title><xsl:value-of select="head/title" /></title>
 <info>
  <metadata>
   <xsl:attribute name = "owner"><xsl:value-of select="head/ownerName" /></xsl:attribute>
  </metadata>
  </info>
 <desc>
  Created <xsl:value-of select="head/dateCreated" />
  Last-modified <xsl:value-of select="head/dateModified" />
 </desc>
 <xsl:apply-templates select = "body"/>
</xbel>
</xsl:template>

<xsl:template match = "outline" >
 <xsl:choose>
  <xsl:when test="child::node()[1]">
   <xsl:call-template name = "folder" />
  </xsl:when>
  <xsl:otherwise>
   <xsl:call-template name = "bookmark" />
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>


<xsl:template name = "bookmark">
  <xsl:choose>
   <xsl:when test="@type='link'">
    <bookmark id = "{generate-id()}">
     <xsl:attribute name = "href">
      <xsl:value-of select = "@url" />
     </xsl:attribute>
     <title><xsl:value-of select = "@text" /></title>
    </bookmark>
   </xsl:when>
   <xsl:otherwise>
    <bookmark id = "{generate-id()}">
     <title><xsl:value-of select = "@text" /></title>
    </bookmark>    
   </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name = "folder">
 <folder id = "{generate-id()}">
 <xsl:choose>
  <xsl:when test="@isComment='true'">
   <title />
   <desc>
    <xsl:call-template name = "comment" />
   </desc>
  </xsl:when>
  <xsl:otherwise>
   <title>
    <xsl:value-of select = "@text" disable-output-escaping = "yes" />
   </title>
   <desc>
    <xsl:call-template name = "comment" />
   </desc>
  </xsl:otherwise>
 </xsl:choose>
 <xsl:apply-templates />
</folder>
</xsl:template>

<xsl:template name = "comment">
 <xsl:for-each select = "child::node()">
  <xsl:if test="@isComment='true'">[ <xsl:value-of select = "@text" /> ]</xsl:if>
 </xsl:for-each>
</xsl:template>

</xsl:stylesheet>


